#
/*
 *		M U L T I - D E V I C E   Q U E U E I N G   S Y S T E M
 *
 *
 *			      Douglas P. Kingston III
 *
 *			       N E X T S E Q N O . C
 *
 *	-----------------------------------------------------------------------
 *
 *				Revision History
 *				================
 */

#include <stdio.h>
#include "queue.h"

extern	char *Seqfile;


/*
 *		N E X T S E Q N O  ( )
 *  This function will search through the queue and find the next
 *  available sequence number for the UID specified.
 */
nextseqno (uid)
register int	uid;
{
	register int	fd;
	int	seq;

	if(( fd = open( Seqfile, RW )) < 0 ) {
		complain( "Can't open sequence file (%s)", sys_errlist[errno]);
		return( -1 );
	}

	lseek( fd, (long)(uid * sizeof( int )), 0 );
	seq = 0;
	read( fd, &seq, sizeof( int ) );
	if( seq == 32767 )
		seq = 0;
	seq++;
	lseek( fd, (long)(uid * sizeof( int )), 0 );
	if( write( fd, &seq, sizeof( int ) ) < 0 ) {
		complain( "Can't rewrite sequence file (%s)", sys_errlist[errno]);
		return( -1 );
	}
	close( fd );
	return( seq );
}
